var MINIVIEW = function(){
	
	var initialized = false;
	var feedUrl = "http://spotlight.reuters.com/api/feed/uk/channelphotos/generalNewsPhotos/rss?apikey=8bf5c76c30241f7b82a2224c91a9be72&version=1.0"; 
	var headline = null;
	var headlineData = null;
	var maxChars = 70;
	var numItems = -1;
	var secsToReload = 1200;
	var timeOfReload = -1;
	var retryTimeout = -1;
	var displayInterval = -1;	
	var refreshDisplayRate = 10;
	var currentItem = 0;
	
	// testing
	if(typeof(widget) === 'undefined'){
		widget = false;
	}
	
	var init = function(){
		initialized = true;
		headline = document.getElementById('headline');
		headlineData = {headlines:[]};
	};

	var loadFeed = function(){
		var callback = { 
			success: feedSuccess,
			failure: feedFail
		};		
		var request = YAHOO.util.Connect.asyncRequest('GET', feedUrl, callback, null);
	};
	
	var feedSuccess = function (o){		
		if(o.responseXML !== undefined){    
			var result = o.responseXML;
			var items = result.getElementsByTagName('item');			
			if(!items.length){
				feedFail(o);
			} else {
				// clear old headlines
				headlineData.headlines.length = 0;
			}
			var n = items.length;
			for(var i=0; i<n; i++){
				var h = items[i].getElementsByTagName('title')[0].firstChild.nodeValue;
				// don't add duplicate titles
				var isNew = true;
				if(i>0){
					if(h === headlineData.headlines[i-1]){
						isNew = false;
					}	
				}
				if(isNew){					
					headlineData.headlines.push(h);
				}
			}
			resetTimer();		
		} else {
			feedFail(o);
		}			
	};
	
	var feedFail = function (o){
		if(headlineData.headlines.length){
			// contine with old headlines, try again next time
			resetTimer();
		} else {		
			// nothing to show
			headline.innerHTML = "<img src=\"fail.png\">";			
			retryTimeout = setTimeout(loadFeed, 60*1000);
		}
	};
	
	var resetTimer = function (){
		var d = new Date();
		timeOfReload = d.getTime();
		numItems = headlineData.headlines.length;	
		currentItem = 0;		
		refreshDisplay();
		displayInterval = setInterval(refreshDisplay, refreshDisplayRate*1000);
	};
	
	var refreshDisplay = function (){
		if(currentItem === 0){
			var d = new Date();
			// is it time to reload feed yet?
			if(((d - timeOfReload)/1000) > secsToReload){
				// console.log('reload feed');
				// stop headline refreshes
				clearInterval(displayInterval);
				headline.innerHTML = "<img src=\"loading.gif\">";
				// reload feed
				loadFeed();
				return;
			}
			// otherwise carry on...
		}
		// display next headline
		var s = headlineData.headlines[currentItem];
		if(s.length > maxChars) {
			s = s.substring(0, maxChars-3) + "...";
		}
		headline.innerHTML = s;
		currentItem = (currentItem+1)%numItems;
	};
	
	var onShow = function(){
		// console.log('show miniview');
		if(!initialized){
			init();
		}
		loadFeed();		
	};
	
	var onHide = function(){
		// console.log('hide miniview');
		// stop headline refreshes
		clearInterval(displayInterval);
		// stop retry
		clearTimeout(retryTimeout);
	};
		
	// return public properties/methods
	return {
		onShow:onShow, onHide:onHide
	};
	
}();