﻿var UI = function(){
	
	// 'constants' (values to be taken from CONFIG object)
	var VERSION_STRING;	
	var WIDGET_ID;
	var REGION_CODE;	
	var LANG_CODE;
	var UPDATE_URL;	
	var UPDATE_MSG;
	var UPDATE_FAIL_MSG;
	var SWF_URL;
	var SWF_WIDTH;
	var SWF_HEIGHT;
	var SWF_BG;
	
	var checkedForUpdate;
	var activeView;	// id of visible content div 
	var transitionState;
	
	// testing
	if(typeof(widget) === 'undefined'){
		widget = false;
	}
	
	var init = function(){		
		if(typeof(CONFIG) === 'undefined'){
			return;
		}
		var c = CONFIG;
		
		VERSION_STRING = c.versionString;
		WIDGET_ID = c.widgetId;
		REGION_CODE = c.region_code;
		LANG_CODE = c.lang_code;
//		alert(LANG_CODE + REGION_CODE);
		UPDATE_URL = c.updateUrl;
		UPDATE_MSG = c.updateMsg;
		UPDATE_FAIL_MSG = c.updateFailMsg;
		SWF_URL = c.swfUrl;
		SWF_WIDTH = c.swfWidth;
		SWF_HEIGHT = c.swfHeight;
		SWF_BG = c.swfBg;
		
		checkedForUpdate = false;
		transitionState = "fade";
		
		// set landscape
		if(widget){
			widget.setDisplayLandscape();
		}

		// hide soft keys
		hideSoftKeys();		
		
		window.onresize = resizing;
		
		setMyLayout();
		
	};
	
	var showView = function (view){		
		if(activeView === view){
			return false;
		} 
									
		// catch first time main is displayed
		if((view === "Widget") && (!checkedForUpdate)){
			checkForWidgetUpdate();		
			return;
		}
		
		if((activeView === "WidgetMini") && (view === "Widget")){
			MINIVIEW.onHide();
		}
		
		if(view === "WidgetMini"){
			MINIVIEW.onShow();
		}
			
		if(widget){
			widget.prepareForTransition(transitionState);		
		}
		if(typeof(activeView) !== 'undefined'){
			// hide current view
			get(activeView).style.display = "none";
		}
		get(view).style.display = "block";
		
		setTimeout(function(){if(widget){widget.performTransition()}}, 5);
		activeView = view;
	};
	
	var setMyLayout = function (){
		var v = "Widget";
		var h =  window.innerHeight; // widget? window.innerWidth : window.innerHeight;
		var a = window.innerWidth * window.innerHeight;
		if ((h < 150) && (a <= 28665)) {
//		if ((h < 450)) {	
			// window.innerHeight for MiniView is actually 91px			
			v = "WidgetMini";
		}
		showView(v);			
	};
			
	var resizing = function(){
		setMyLayout();
	};
	
	var showing = function(){
		setMyLayout();
	};
	
	var checkForWidgetUpdate = function (){
		checkedForUpdate = true;
		var callback = {
		  success:checkWidgetUpdateSuccess,
		  failure:checkWidgetUpdateFailure
		};		
		var url = UPDATE_URL + '?version=' + VERSION_STRING + '&id=' + WIDGET_ID + '&lang=' + LANG_CODE + '&region=' + REGION_CODE;
//		alert(url);
		var transaction = YAHOO.util.Connect.asyncRequest('GET', url, callback);
	};
	
	// called from success/fail handler of checkForWidgetUpdate
	var embedFlashContent = function (){						
		var w = get('Widget');		
		var obj = document.createElement('OBJECT');
		// add event handlers for soft key fix
		obj.onfocus = hideSoftKeys;
		obj.onmousedown = hideSoftKeys;
		// set attributes
		obj.setAttribute("data", SWF_URL);
		obj.setAttribute("flashvars", 'REGION_CODE=' + REGION_CODE);
		obj.setAttribute("type", "application/x-shockwave-flash");	
		obj.setAttribute("width", SWF_WIDTH);
		obj.setAttribute("height", SWF_HEIGHT);
		obj.setAttribute("loop", "false");
		var p0 = document.createElement('PARAM');
		p0.setAttribute("name", "bgcolor");
		p0.setAttribute("value", SWF_BG);
		var p1 = document.createElement('PARAM');
		p1.setAttribute("name", "quality");		
		p1.setAttribute("value", "high");
		obj.appendChild(p0);
		obj.appendChild(p1);
		// append to DOM
		w.appendChild(obj);
	};			
	
	var hideSoftKeys = function(){
		if(window.menu){
			window.menu.hideSoftkeys();
		}
	};
	
	var checkWidgetUpdateSuccess = function(o){
		var r = o.responseXML;
		if(!r){
			checkWidgetUpdateFailure();
		}
		if(r.getElementsByTagName('version').length && r.getElementsByTagName('url').length){
			// assumes tags are not empty...
			var v = r.getElementsByTagName('version')[0].firstChild.nodeValue;
			var u = r.getElementsByTagName('url')[0].firstChild.nodeValue;			

			// convert version strings to numbers and compare
			var numA = getVersionNumbers(VERSION_STRING);
			var numB = getVersionNumbers(v);			
			var isOld = false;
			if(numB.major > numA.major){
				isOld = true;
			} else {
				if(numB.major === numA.major){
					if(numB.minor > numA.minor){
						isOld = true;			
					} else {
						if(numB.minor === numA.minor){
							if(numB.revision > numA.revision){
								isOld = true;
							}
						}
					}
				}	
			}

			if(isOld && u !== ""){
				// show prompt to auto update
				var c = confirm(UPDATE_MSG);
				if(c){
					widget.openURL(u);
				} else {
					// update refused move on silently
					embedFlashContent();
					showView("Widget");
				}							
			} else {			
				// no update available) move on silently
				embedFlashContent();
				showView("Widget");
			}
		}  else {
			checkWidgetUpdateFailure();
		}	 	
	};
		
	var getVersionNumbers = function (versionString){
		var vArray = versionString.split(".");
		var obj = {
			major: parseInt(vArray[0]),
			minor: vArray[1] ? parseInt(vArray[1]) : 0,
			revision: vArray[2] ? parseInt(vArray[2]) : 0
		};
		return obj;
	};
		
	var checkWidgetUpdateFailure = function(o){
		// status 0 = no response, -1 = abort
		if(status !== -1){
			// alert user
			alert(UPDATE_FAIL_MSG);
			// tidy/free memory?
			// then close
			window.close();			
		}			
	};	
	
	var openURL = function (urlString){
		widget.openURL(urlString);
	};
	
	var get = function(elId){
		return document.getElementById(elId);
	};	
	
	// return public properties/methods
	return {
		init:init, openURL:openURL
	};
	
}();